<template>
  <div>
    <v-sheet>
      <v-card-title>
        <v-tooltip bottom v-model="show">
          <template v-slot:activator="{ attrs }">
            <v-text-field
              v-model="search"
              append-icon="mdi-magnify"
              label="Search"
              v-bind="attrs"
              single-line
              hide-details
            ></v-text-field>
          </template>
          <span>{{ answer }}</span>
        </v-tooltip>
        <v-spacer></v-spacer>
        <v-btn
          class="ma-2 success"
          dark
          @click="handleCreateData"
          tile
          outlined
        >
          <v-icon>mdi-plus</v-icon>เพิ่ม
        </v-btn>
      </v-card-title>
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <v-data-table
        :headers="headers"
        :items="tablesData"
        :items-per-page="10"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        :search="search"
        item-key="id"
        multi-sort
        class="elevation-1"
      >
        <template #item.price="{ item }">
          <moneyFormat :getPrice="item.price" />
        </template>
        <template #item.date="{ item }">
          <dateFormat :getDate="item.date" />
          <!-- <dateFormat :getDate="item.date"> -->
        </template>
        <template #item.action="{ item }">
          <!-- <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                class="mr-1 mb-2"
                color="blue darken-2"
                v-bind="attrs"
                v-on="on"
                small
                dark
              >
                <v-icon icon small dark> mdi-map-marker </v-icon>
              </v-btn>
            </template>
            <span>พิกัด</span>
          </v-tooltip> -->
          <v-tooltip v-if="item.doc != '-'" bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                class="mr-1 mb-2"
                color="green darken-2"
                v-bind="attrs"
                v-on="on"
                small
                dark
                :href="item.doc"
                target="_blank"
              >
                <v-icon icon small dark> mdi-image-multiple-outline </v-icon>
              </v-btn>
            </template>
            <span>เอกสาร</span>
          </v-tooltip>
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                class="mr-1 mb-2"
                color="orange darken-2"
                v-bind="attrs"
                v-on="on"
                small
                dark
                @click="handleEditdata(item)"
              >
                <v-icon small dark> mdi-pencil </v-icon>
              </v-btn>
            </template>
            <span>แก้ไข</span>
          </v-tooltip>
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                class="mr-1 mb-2"
                color="red darken-2"
                v-bind="attrs"
                v-on="on"
                small
                dark
                @click="handleDeldata(item)"
              >
                <v-icon small> mdi-delete </v-icon>
              </v-btn>
            </template>
            <span>ลบ</span>
          </v-tooltip>
        </template>
      </v-data-table>
    </v-sheet>
  </div>
</template>
<script>
import Swal from 'sweetalert2'
import dateFormat from '@/components/functional/dateFormat'
import moneyFormat from '@/components/functional/moneyFormat'
import { mapGetters, mapActions, mapState } from 'vuex'
import _ from 'lodash'

import getExpenses from '~/mixins/getExpenses'

export default {
  created() {
    /*
    this.debouncedGetAnswer = _.debounce(this.getAnswer, 500)
    */
  },
  watch: {
    /*
    search(newSearch, oleSearch) {
      this.debouncedGetAnswer()
    },
    */
    async getExpensesTable() {
      this.tablesData = this.$nuxt.$store.state.expensestable.ExpensesTable
    },
  },
  components: {
    dateFormat,
    moneyFormat,
  },
  props: ['itemData'],
  mixins: [getExpenses],
  data() {
    return {
      search: '',
      show: false,
      sortBy: ['date', 'no', 'listExpenses'],
      sortDesc: true,
      tablesData: [],
      itemListData: '',
      answer: 'I cannot give you an answer until you ask a question!',
      headers: [
        {
          text: 'เลขใบเสร็จ',
          value: 'no',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ประเภทค่าใช้จ่าย',
          value: 'listExpenses.name',
          align: 'center',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'จำนวน',
          align: 'center',
          value: 'amount',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'หน่วย',
          value: 'unitExpenses.name',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ราคา',
          value: 'price',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'วันที่ซื้อสินค้า',
          value: 'date',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ร้านค้า',
          value: 'storesExpenses.name',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'รายละเอียด',
          value: 'detail',
          align: 'center',
          sortable: false,
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'เครื่องมือ',
          align: 'center',
          value: 'action',
          width: '20%',
          sortable: false,
          class: 'subtitle-2 font-weight-bold ',
        },
      ],
    }
  },
  computed: {
    // ...mapState({
    //   // tableData: (store) => store.expensestable.ExpensesTable,
    // }),
  },
  mounted() {},
  methods: {
    /*
    getAnswer() {
      if (this.search == '') {
        // console.log('search IN', this.search)
        this.tablesData = this.itemData
      } else {
        let val = this.search
        console.log('val', val)
        let res = this.tablesData.filter(
          (it) =>
            it.listExpenses.name == val ||
            it.unitExpenses.name.includes(val) ||
            it.storesExpenses.name.includes(val) ||
            it.no.includes(val) ||
            it.price == val ||
            it.amount == val ||
            it.date.includes(val) ||
            it.detail.includes(val)
        )
        if (res.length == 0) {
          this.show = true
          setInterval(() => {
            this.show = false
          }, 500)
          console.log('res length', res)
        } else {
          console.log('res else', res)
          this.show = false
          this.tablesData = res
        }
        // this.tablesData = res
        console.log('res', res)
      }
    },*/
    handleCreateData() {
      //เพิ่ม 1 (TableForm) แสดงฟอร์มสำหรับเพิ่มข้อมูล
      //เพิ่ม 1.1 (TableForm) Set Commit จัดการ EditItem ล่าสุด  เข้า State สำหรับ กดหนด Add/Edit
      this.$store.commit('SET_Expenses_Table_EditItem', -1)
      //เพิ่ม 1.2 (TableForm) Set Commit จัดการ formExpensesTable ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit(
        'SET_FORM_EXPENSES_TABLE',
        !this.$nuxt.$store.state.expensestable.formExpensesTable
      )
    },
    handleEditdata(val) {
      //แก้ไข 1 (TableForm) แสดงฟอร์มสำหรับแก้ไขข้อมูล

      this.editIndex = 1
      //แก้ไข 1.1 (TableForm) Set Commit จัดการ formExpensesTable ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_Table_EditItem', 1)
      //เพิ่ม 1.2 (TableForm) Set Commit จัดการ formExpensesTable ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_FORM_EXPENSES_TABLE', true)
      //เพิ่ม 1.3 (TableForm) Set Commit จัดการ val เข้า  ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_Table_EditData', val)
    },
    handleDeldata(val) {
      //ลบ 1 (TableForm)ลบข้อมูล
      Swal.fire({
        title: 'คุณแน่ใจหรือไม่',
        text: 'คุณต้องการลบข้อมูลนี้',
        icon: 'warning',
        showCancelButton: true,
        cancelButtonColor: '#0288D1',
        confirmButtonColor: '#D32F2F',
        cancelButtonText: 'ยกเลิก',
        confirmButtonText: 'ใช่, ลบข้อมูล',
      }).then((result) => {
        if (result.isConfirmed) {
          //ลบ 1 (TableForm) dispatch พร้อม parameter "val" ไปยัง Fnc ลบข้อมูล
          this.$store.dispatch('delDataexpensesTable', val).then(() => {
            Swal.fire('ลบข้อมูล', 'คุณได้ลบข้อมูลเรียบร้อยแล้ว', 'success')
          })
        }
      })
    },
  },
}
</script>
<style scoped>
.v-sheet {
  border-radius: 4px !important;
  border: thin solid rgba(0, 0, 0, 0.12);
  border-width: 2px;
  background-color: #fff;
}
</style>
